package první;

import java.util.concurrent.locks.*;

class Semafor
{
    public static void přepni()
    {
        kočkaJeNaŘadě = !kočkaJeNaŘadě;
    }
    public static boolean ještěNejsemNaŘadě(boolean  kdo)
    {
        return kdo != kočkaJeNaŘadě;
    }
    public static boolean kočkaJeNaŘadě = true;
}

class Verš implements Runnable
{
    private final String text;
    private final boolean jsemKočka;
    private static final int počet = 10;
    private static final Lock zámek = new ReentrantLock();
    private static final Condition píšeKočka = zámek.newCondition();
    private static final Condition píšePes = zámek.newCondition();
    
    public Verš(String txt, boolean jsemKočka)
    {
        text = txt;
        this.jsemKočka = jsemKočka;
    }
    
    @Override
    public void run() 
    {
        for (int i = 0; i < počet; i++)
        {
            vypiš();
        }
    }
    
    private synchronized void vypiš()
    {
        try
        {
            zámek.lock();
            try
            {
                while(Semafor.ještěNejsemNaŘadě(jsemKočka))
                {
                    if(jsemKočka)píšeKočka.await();
                    else píšePes.await();
                }
                System.out.println(text);
                Semafor.přepni();
                if(jsemKočka)píšePes.signal();
                else píšeKočka.signal();
            }
            finally
            {
                zámek.unlock();
            }
                
        }
        catch(InterruptedException e)
        {
            e.printStackTrace();
        }
    }
    
}

public class Program 
{
    public static void main(String[] args) throws InterruptedException 
    {
        Verš verš1 = new Verš("Kočka leze dírou", true);
        Verš verš2 = new Verš("Pes oknem", false);
        Thread výpis1 = new Thread(verš1);
        Thread výpis2 = new Thread(verš2);
        výpis1.start();
        výpis2.start();
        výpis1.join();
        výpis2.join();
    }
    
}
