package budoucí;

import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

class Verš implements Callable<String>
{
    private static Random generátor = new Random();
    private String text;
    
    public Verš(String text)
    {
        this.text = text;
    }
    
    public String call() throws Exception
    {
        StringBuilder výsledek = new StringBuilder();
        for(int i = 0; i < text.length(); i++)
        {
            výsledek.append(text.charAt(i));
            Thread.sleep(generátor.nextInt(100));
        }
        return výsledek.toString();
    }
}

public class Program 
{
    private static String[] texty = {"Kočka leze dírou", "pes oknem", "nebude-li pršet", "nezmoknem"};
    private static ArrayList<Future<String>> budoucíVýsledky = new ArrayList<>();
    
    public static void main(String[] args) throws InterruptedException, ExecutionException 
    {
        ExecutorService vykonavatel = Executors.newCachedThreadPool();
        for(var s: texty)
        {
            budoucíVýsledky.add(vykonavatel.submit(new Verš((s))));
        }
        vykonavatel.shutdown();
        vykonavatel.awaitTermination(1, TimeUnit.DAYS);
        for(var s: budoucíVýsledky)
        {
            System.out.println(s.get());
        }
    }
    
}
