package úlohandam;

import dámy.Řešitel;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class HlavníOkno extends JFrame
{
    public HlavníOkno()
    {
        super("Úloha N dam");
        připravOkno();
        připravNabídku();
        připravPanelNástrojů();
        vložIkony();
        připravBubliny();
        nastavObsluhy();
    }
    
    private void připravOkno()
    {
        Dimension obrazovka = Toolkit.getDefaultToolkit().getScreenSize();
        this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        this.setSize(new Dimension(Nastavení.šířkaOkna, Nastavení.výškaOkna));
        this.setLocation(obrazovka.width/2 - Nastavení.šířkaOkna/2, obrazovka.height/2 - Nastavení.výškaOkna/2);
        setLayout(new BorderLayout());
        setJMenuBar(pruhNabídky);
        add(panelNástrojů, BorderLayout.NORTH);
        add(panel, BorderLayout.CENTER);
        dialogNastavení = new DialogNastavení(this, this.getLocation());
        addWindowListener(new WindowAdapter()
           {
               @Override public void windowClosing(WindowEvent e)
               {
                   obsluhaUkončení(e);
               }
           });
    }
    
    private void připravNabídku()
    {
        pruhNabídky.add(nabídkaÚloha);
        pruhNabídky.add(nabídkaNastavení);
        pruhNabídky.add(nabídkaNápověda);
        nabídkaÚloha.add(nabídkaNová);
        nabídkaÚloha.add(nabídkaDalšíŘešení);
        nabídkaÚloha.add(nabídkaCelkovýPočet);
        nabídkaÚloha.addSeparator();
        nabídkaÚloha.add(nabídkaKonec);
        nabídkaNastavení.add(nabídkaUpravit);
        nabídkaNápověda.add(nabídkaOProgramu);                            
    }
    
    private void nastavObsluhy()
    {
        nabídkaNová.addActionListener(this::obsluhaNová);
        tlačítkoNová.addActionListener(this::obsluhaNová);
        nabídkaDalšíŘešení.addActionListener(this::obsluhaDalší);
        tlačítkoDalšíŘešení.addActionListener(this::obsluhaDalší);
        nabídkaUpravit.addActionListener(this::obsluhaUpravit);
        nabídkaCelkovýPočet.addActionListener(this::obsluhaCelkovýPočet);
        tlačítkoCekovýPočet.addActionListener(this::obsluhaCelkovýPočet);
        nabídkaKonec.addActionListener(e -> obsluhaUkončení(null));
    }
    
    private void připravPanelNástrojů()
    {
        panelNástrojů.add(tlačítkoNová);
        panelNástrojů.add(tlačítkoDalšíŘešení);
        panelNástrojů.add(tlačítkoCekovýPočet);
        panelNástrojů.addSeparator();
        panelNástrojů.add(nápisPočet);
        panelNástrojů.add(postup);
        postup.setMinimum(0);
    }
    
    private void vložIkony()
    {
        nabídkaNová.setIcon(new ImageIcon(ikony.Ikony.class.getResource("menu_new.png")));
        nabídkaDalšíŘešení.setIcon(new ImageIcon(ikony.Ikony.class.getResource("menu_run.png")));
        nabídkaCelkovýPočet.setIcon(new ImageIcon(ikony.Ikony.class.getResource("Suma.png")));
        tlačítkoNová.setIcon(new ImageIcon(ikony.Ikony.class.getResource("menu_new.png")));
        tlačítkoDalšíŘešení.setIcon(new ImageIcon(ikony.Ikony.class.getResource("menu_run.png")));
        tlačítkoCekovýPočet.setIcon(new ImageIcon(ikony.Ikony.class.getResource("Suma.png")));  
    }
    
    private void připravBubliny()
    {
        tlačítkoNová.setToolTipText("Nová úloha");
        tlačítkoDalšíŘešení.setToolTipText("Najdi další řešení");
        tlačítkoCekovýPočet.setToolTipText("Celkový počet řešení");
    }
    
    // Obsluhy
    private void obsluhaNová(ActionEvent e)
    {
        řešitel = new Řešitel(Nastavení.getPočetDam());
        nápisPočet.setText("Počet dam: " + Nastavení.getPočetDam());
    }
    
    private void obsluhaDalší(ActionEvent e)
    {
        if(řešitel == null) return;
        if(řešitel.najdiDalšíŘešení())
        {
            nakresliŘešení();
        }
        else
        {
            řešitel = null;
            JOptionPane.showMessageDialog(rootPane, "Další řešení neexistují", "To je vše",JOptionPane.OK_OPTION);
            repaint();
        }

    }
    
    private void obsluhaUkončení(WindowEvent e)
    {
        int rozhodnutí = JOptionPane.showConfirmDialog(rootPane, "Opravdu chceš skončit?", "Prosím potvrzení", JOptionPane.YES_NO_OPTION);
        if(rozhodnutí == JOptionPane.OK_OPTION)
        {
            System.exit(0);
        }
    }
    
    private void obsluhaUpravit(ActionEvent e)
    {
        dialogNastavení.setVisible(true);
    }
    
    private void obsluhaCelkovýPočet(ActionEvent e)
    {
//        Řešitel lokálníŘešitel = new Řešitel(Nastavení.getPočetDam());
//        lokálníŘešitel.najdiVšechnaŘešení();
//        String text = String.format("Úloha %d dam má %d řešení", Nastavení.getPočetDam(), lokálníŘešitel.getPočetNalezenýchŘešení());
//        JOptionPane.showMessageDialog(rootPane, text, "Celkový počet řešení", JOptionPane.INFORMATION_MESSAGE);
       postup.setMaximum(Nastavení.getPočetDam());
       Výpočet výpočet = new Výpočet();
       výpočet.execute();
    }
    
    private void nakresliŘešení()
    {
        řešení = řešitel.getŘešení();
        nakresleno = true;
        repaint();
    }

    
    // Datové složky
    private Label nápisPočet = new Label("Počet dam: " + Nastavení.getPočetDam());
    private final JMenuBar pruhNabídky = new JMenuBar();
    private final JMenu nabídkaÚloha = new JMenu("Úloha");
    private final JMenu nabídkaNastavení = new JMenu("Nastavení");
    private final JMenu nabídkaNápověda = new JMenu("Nápověda");
    private final JMenuItem nabídkaNová = new JMenuItem("Nová");
    private final JMenuItem nabídkaDalšíŘešení = new JMenuItem("Další řešení");
    private final JMenuItem nabídkaCelkovýPočet = new JMenuItem("Celkový počet řešení...");
    private final JMenuItem nabídkaKonec = new JMenuItem("Konec");
    private final JMenuItem nabídkaUpravit = new JMenuItem("Upravit...");
    private final JMenuItem nabídkaOProgramu = new JMenuItem("O programu...");
    
    private final JToolBar panelNástrojů = new JToolBar();
    private final JButton tlačítkoNová = new JButton();
    private final JButton tlačítkoDalšíŘešení = new JButton();
    private final JButton tlačítkoCekovýPočet = new JButton();
    private final JPanel panel = new Panel();
    
    private JProgressBar postup = new JProgressBar();
    
    private DialogNastavení dialogNastavení = null;
    
    private Řešitel řešitel = null;
    private int[] řešení = null;
    private boolean nakresleno = false;
    
    ////////////////////////////////////////
    private class Panel extends JPanel
    {
        public Panel() { }

        @Override
        public void paintComponent(Graphics grafika)
        {
            super.paintComponent(grafika);
            
            if(HlavníOkno.this.nakresleno)
            {
                příprava(this.getSize(), grafika);
                nakresliŠachovnici();
                nakresliDámy();
            }
        }

        private void nakresliŠachovnici()
        {
            for(int i = 1; i < n; i++)
            {
                grafika.drawLine(0, (int)(i*krok_y), rozměry.width, (int)(i*krok_y));
                grafika.drawLine((int)(i*krok_x), 0, (int)(i*krok_x), rozměry.height);
            }
        }

        private void příprava(Dimension rozměry, Graphics grafika)
        {
            this.grafika = grafika;
            this.rozměry = rozměry;
            this.n = Nastavení.getPočetDam();
            krok_x = rozměry.width/(double)n;
            krok_y = rozměry.height/(double)n;
        }

        private void nakresliDámy()
        {
            for(int i = 0; i < n; i++)
            {
                double x1 = i*krok_x + krok_x/5;
                double y1 = řešení[i]*krok_y + krok_y/5;
                grafika.fillOval((int)x1, (int)y1, (int)(3*krok_x/5), (int)(3*krok_y/5));
            }
        }

        private int n;
        private double krok_x, krok_y;
        private Dimension rozměry;
        private Graphics grafika;
    }
    
    /////////////////////////////////////
    class Výpočet extends SwingWorker<Void, Integer>
    {
        @Override
        protected Void doInBackground() throws Exception
        {
            řešitel = new Řešitel(Nastavení.getPočetDam());
            //řešitel.najdiVšechnaŘešení();
            int stav = 0;
            while(řešitel.najdiDalšíŘešení())
            { 
                if(řešitel.getŘešení()[0] > stav)
                {
                    stav = řešitel.getŘešení()[0];
                    this.publish(stav);
                }
            }
            return null;
        }
        @Override 
        protected void done()
        {
            postup.setValue(Nastavení.getPočetDam());
            String text = String.format("Úloha %d dam má %d řešení", Nastavení.getPočetDam(), řešitel.getPočetNalezenýchŘešení());
            JOptionPane.showMessageDialog(rootPane, text, "Celkový počet řešení", JOptionPane.INFORMATION_MESSAGE);
            postup.setValue(0);
        }
        
        @Override
        protected  void process(java.util.List<Integer> kousky)
        {
            if(!kousky.isEmpty())
            {
                postup.setValue(kousky.get(kousky.size()- 1));
                kousky.clear();
            }
        }
        
        private Řešitel řešitel;
        
    }

}
